      subroutine DeclareNtupleBlocks(FromTracker)

#include "ntuple.inc"
#include "vertexNtuple.inc"
#include "fitterNtuple.inc"
#include "vector.inc"
#include "viewData.inc"
#include "moduleData.inc"
#include "dEdxData.inc"

      INTEGER iErr, LNBLNK, iCyc, nRmEvents,nRmHits,nRmDigHits
      INTEGER nRmVtx, nRmCoord
      INTEGER iStrip, iMod, iRmEvent, idig, iAbs, iMat, i
      REAL ANGLEREC,ANGELTRUE,veclength,delta_angle
      logical FromTracker

      if (FromTracker) then
       iCyc = 99999
       CALL HRIN(1,iCyc,10000)
       CALL HRIN(2,iCyc,10000)
       CALL HRIN(3,iCyc,10000)
       CALL HRIN(9,iCyc,10000)
       CALL HRIN(898,iCyc,10000)
       CALL HRIN(899,iCyc,10000)

       CALL HBNAME(10001,' ',0,'$CLEAR')
       CALL HBNAME(10001,'RUN',nRun,'$SET')
       CALL HBNAME(10001,'REACTION',nt_cc,'$SET')
       CALL HBNAME(10001,'LEPTONS',nt_nleptons,'$SET')
       CALL HBNAME(10001,'HADRONS',nt_nhadrons,'$SET')
       CALL HBNAME(10001,'TRUTH',ntruth,'$SET')
       CALL HBNAME(10001,'RECON',nrecon,'$SET')
       CALL HBNAME(10001,'MINOS',nminos,'$SET')
c      call HBNAME(10001,'STMIN',nstminos,'$SET')
c      call HBNAME(10001,'ESCAPE',nescape,'$SET')
c******
       CALL HBNAME(10002,' ',0,'$CLEAR')
       CALL HBNAME(10002,'RUN',nrun,'$SET')
       CALL HBNAME(10002,'TRUTH',ntruth,'$SET')
       CALL HBNAME(10002,'RAWHIT',nhit,'$SET')
       CALL HBNAME(10002,'BARHIT',nbhit,'$SET')
c **************
      CALL HBNAME(10003,' ',0,'$CLEAR')
      CALL HBNAME(10003,'RUN',nrun,'$SET')
      CALL HBNAME(10003,'DIGHIT',ndig,'$SET')
      CALL HBNAME(10003,'DIGBAR',ndbar,'$SET')
c ********************* 
      CALL HBNAME(10009,' ',0,'$CLEAR')
      CALL HBNAME(10009,'CalObj',nCal,'$SET')
c ********************* 
       CALL HNOENT(10001,nRmEvents)
       CALL HNOENT(10002,nRmHits)
       CALL HNOENT(10003,nRmDigHits)
       PRINT *,'owl: Input file contains ',nRmEvents, ' events'
       PRINT *,'owl: Input hits contains ',nRmhits, ' events'
       PRINT *,'owl: Input hits contains ',nRmDigHits, ' events'

       CALL HBNAME(10898,'VTX',nVtrk,'$SET')
       CALL HBNAME(10899,'TRKS',nCoord,'$SET')
       CALL HBNAME(10899,'DEDX',ndEdxPts,'$SET')

       CALL HNOENT(10898,nRmVtx)
       CALL HNOENT(10899,nRmCoord)
c      CALL HNOENT(10899,nSample)
       PRINT *,'owl: Number of vertices ',nRmVtx
       PRINT *,'owl: Number of coords ',nRmCoord
c       PRINT *,'owl: Number of samples ',nSample

      else

       iCyc = 99999
       CALL HRIN(2,iCyc,10000)
       CALL HRIN(3,iCyc,10000)
       CALL HRIN(4,iCyc,10000)
       CALL HRIN(5,iCyc,10000)
       CALL HRIN(0,iCyc,10000)
       CALL HBNAME(10005,' ',0,'$CLEAR')
       CALL HBNAME(10005,'RUN',nRun,'$SET')
       CALL HBNAME(10005,'REACTION',nt_cc,'$SET')
       CALL HBNAME(10005,'LEPTONS',nt_nleptons,'$SET')
       CALL HBNAME(10005,'HADRONS',nt_nhadrons,'$SET')
       CALL HBNAME(10005,'RUN',nrun,'$SET')
       CALL HBNAME(10005,'TRUTH',ntruth,'$SET')
       CALL HBNAME(10005,'DIGHIT',ndig,'$SET')
       CALL HNOENT(10005,nRmEvents)
       PRINT *,'owl: Input file contains ',nRmEvents, ' events'

       CALL HBNAME(10002,'GEODET',gStrips,'$SET')
       CALL HBNAME(10002,'FWDMAT',gnFwd,'$SET')
       CALL HBNAME(10002,'BCKMAT',gnBack,'$SET')
       CALL HBNAME(10003,'GEOABS',nAbsSections,'$SET')
       CALL HBNAME(10004,'GEOMOD',mType,'$SET')
       CALL HNOENT(10002,nRmModules)
       CALL HNOENT(10003,nRmAbsTypes)
       CALL HNOENT(10004,nRmModTypes)
 
       IF (nRmModules .GT. maxModules) THEN
           PRINT *,'owl: Number of modules exceeds the maximum.'
           STOP
       ENDIF
       IF (nRmModTypes .GT. maxModTypes) THEN
           PRINT *,'owl: Number of module types exceeds the maximum'
           STOP
       ENDIF
       IF (nRmAbsTypes .GT. maxAbsTypes) THEN
           PRINT *, 'owl: Number of absorber types exceeds the maximum'
           STOP
       ENDIF
       DO iMod = 1, nRmModTypes
           CALL HGNT(10004,iMod,iErr)
           IF (iErr .NE. 0) THEN
               PRINT *,'owl: Error reading module type data'
              STOP
           ENDIF
           IF (mType .GT. 0 .AND. mType.LE. maxModTypes) THEN
               stripShape(mType) = mStripShape
              stripLength(mType) = mStripLength
               stripWidth(mType) = mStripWidth
               stripThickness(mType) = mThickness
               stripDensity(mType) = mRhoStrip
               stripRadLength(mType) = mRadStrip
               passiveDensity(mType) = mRho
               passiveRadLength(mType) = mRadLen
           ELSE
               PRINT *,'owl: Invalid module type'
           ENDIF
       ENDDO
 
       DO iAbs = 1, nRmAbsTypes
           CALL HGNT(10003,iAbs,iErr)
           IF (iErr .NE. 0) THEN
               PRINT *,'owl: Error reading material data'
               STOP
           ENDIF
           IF (aType .GT. 0 .AND. aType.LE.maxAbsTypes) THEN
               IF (nAbsSections .LT.1 .OR. 
     +              nAbsSections.GT.maxRmAbsSections) THEN
               PRINT *,'owl: Invalid number of absorber sections'
                   STOP
               ENDIF
               nRmAbsSections(aType) = nAbsSections
               absThickness(aType) = aThickness
               DO i = 1, nAbsSections
                   absDensity(i,aType) = aDensity(i)
                   absRadLength(i,aType) = aRadLen(i)
                   absInnerR(i,aType) = aInner(i)
                   absOuterR(i,aType) = aOuter(i)
               ENDDO
           ELSE
               PRINT *,'owl: Invalid absorber type: ', aType
               STOP
           ENDIF
       ENDDO
 
       DO iMod = 1, nRmModules
           CALL HGNT(10002,iMod,iErr)
           IF (iErr .NE. 0) THEN
               PRINT *,'owl: Error reading geometry data'
               STOP
           ENDIF
           IF (gStrips.LT.0 .OR. gStrips.GT.maxStrips) THEN
               PRINT *,'owl: Number of strips exceeds the maximum'
               STOP
           ENDIF
           IF (gModule.LT.0 .OR. gModule.GT.maxModules) THEN
               PRINT *,'owl: Invalid module number: ',gModule
               STOP
           ENDIF
           IF (gModule .NE. iMod) THEN
               PRINT *,'owl: Module out of order'
               STOP
           ENDIF
           IF (MIN(gnFwd,gnBack).LE.0 .OR. MAX(gnFwd,gnBack).GT.maxMat) THEN
               PRINT *,'owl: Invalid number of material layers'
               STOP
           ENDIF
           nRmStrips(iMod) = gStrips
           xModule(iMod) = gxModule
           yModule(iMod) = gyModule
           zModule(iMod) = gzModule
           modView(iMod) = gView
           modType(iMod) = gmType
c          DO iStrip = 1, gStrips
c              IF (gView.EQ.1) THEN
c                  wStrip(iStrip,gModule) = gyStrip(iStrip)
c                  zStrip(iStrip,gModule) = gzStrip(iStrip)
c              ELSE IF (gView.EQ.2) THEN
c                  wStrip(iStrip,gModule) = gxStrip(iStrip)
c                  zStrip(iStrip,gModule) = gzStrip(iStrip)
c              ELSE
c                  PRINT *,'owl: Unknown view'
c                  STOP
c              ENDIF
c          ENDDO
           nFwd(iMod) = gnFwd
           DO iMat = 1, gnFwd
               fwdMat(iMat,iMod) = gvFwd(iMat)
           ENDDO
           nBck(iMod) = gnBack
           DO iMat = 1, gnBack
               bckMat(iMat,iMod) = gvBack(iMat)
           ENDDO
       ENDDO
       print *,'owl: Geometry data read successfully'

      endif
 
      end
