c This sums pulse height information to get energy
      subroutine hadron_energy_ph(reconList,nprim,e_hads,e_pros,e_pis
     +,w_had_rec,p4hads,ehad_tru,smearhad_err,smearpmom_err
     +,itype,no_int_2had)
c not clear if hadron energy should be energy of non interacting particle or not
c compute p4hads if you can, ie need to know the 
c momentum of all the identified hadrons 
c imuon, ipro,ipi, recon pointers to imuon,proton,and pion 
c e_hads -smeared hadron energy
c itype  tells which one was done
c itype 
c   0  regular hadron smearing
c   1  1 primary - take hadron energy
c   2  1 hadrons - proton, does not interact
c   3  1 hadrons - pion, does not interact
c   4  1 hadron  - proton, interacts
c   5  1 hadron  - proton, interacts
c   6  2 hadrons, proton and pion do not interact
c   no_int_2had = 0, then e_hads and smearhad are returned is the sum of the 2 hadrons
c   7  2 hadrons, proton does not interact, pion does
c   8  2 hadrons, proton interact, pion does not
c   e_pro is the smeared energy of he proton 
c   e_pi  is the smeared energy of the pion
c 
C
#include "ntuple.inc"
#include "vertexNtuple.inc"
#include "fitterNtuple.inc"
#include "vector.inc"
#include  "hb_common.inc"
C
      real p4hads(4)
      integer reconList(5)
      integer iMuon,ipro,ndaughter,num_hits
      external ranlux
      real rand
      integer i_smear_gaus/6/
      real pro_mass/0.9383/
      real pi_mass/0.1396/
      real cal_e_hads /.00116/
      real cal_e_pro /.00116/
      real cal_e_pi /.00116/
C
      n_wrt=nwrt
c     nwrt= -9876
      iMuon=reconList(1)
      ipro=reconList(2)
      ipi=reconList(3)
      nhit_pro=nrechit(ipro)
      nhit_pi=nrechit(ipi)
      e_pro_true=0
      e_pi_true=0
      e_charge_lep=0
      smear_pro_err=0.0
      smear_pro=0.0
      smear_pi=0.0
      smear_pi_err=0.0
      itype=0
      e_pros = 0
      e_pis = 0
      p_pros = 0
      p_pis = 0
      ehad_tru=0
      itpro=0
      itpi=0
      w_had_rec=0
      w_had_rec2=0
      do i=1,4
        p4hads(i)=0
      enddo
      if(ipro.gt.0)then
        itpro=trk(Ipro)
        e_pro_true=petrue(itpro)
        p_pro_true=pxtrue(itpro)**2+pytrue(itpro)**2+pztrue(itpro)**2
        p_pro_true=sqrt(p_pro_true)
      endif
      if(ipi.gt.0)then
        itpi=trk(Ipi)
        e_pi_true=petrue(itpi)
        p_pi_true=pxtrue(itpi)**2+pytrue(itpi)**2+pztrue(itpi)**2
        p_pi_true=sqrt(p_pi_true)
      endif
c get charged leptonic energy
      do ilep=1,nt_nleptons
        if(abs(nt_lepton(ilep)).eq.11.or.abs(nt_lepton(ilep)).eq.13) then
           e_charge_lep=e_charge_lep+nt_plepton(4,ilep)
        endif
      enddo
c subtract off energy of identified muon from total
c phtot(4) is the energy and phtot(5) is the total momentum
      if(Imuon.gt.0)then
        ehad_tru=nt_phtot(4)+e_charge_lep-petrue(trk(Imuon))
      else
        ehad_tru=nt_phtot(4)
      endif
c default smearing and hadron energy
      ph_sum=sum_ph(imuon,0)
      if(nev.le.nwrt)then
        write(6,460)ph_sum
460     format(' calculate energy without muon, sum_ph =',f10.4)
        call wrt_calor(imuon,0) 
      endif
      e_hads = pro_mass + cal_e_hads*ph_sum
      smearhad_err = smear_had_err(e_hads)
      pmomtots = sqrt(e_hads**2-pro_mass**2)
      smearpmom_err = delp_from_dele(smearhad_err,e_hads,pmomtots)
      itype=1
c 1 hadron, and the hadron does not interact
      if(nprim.eq.2.and.iMuon.gt.0.and.(ipro.gt.0.or.ipi.gt.0))then
        if(ipro.gt.0.and.ishower(ipro).eq.0
     +    .and.etrueex(trk(ipro)).lt.0.00001)then
          itype=2
          if(nhit_pro.gt.i_smear_gaus)then
            CALL RNORMX(rand,1,ranlux)
            smear_pro=smearhad_range*p_pro_true
            smear_pro_err=smearhad_range_err*p_pro_true
          else
            smear_pro=1.0/float(nhit_pro)
            smear_pro_err=1.0/float(nhit_pro)
            CALL ranlux(rand,1)
            rand=rand-0.5
          endif
          p_pros = p_pro_true+rand*smear_pro
          e_pros = sqrt(p_pros**2+pro_mass**2)
          smearhad=dele_from_delp(smear_pro,e_pros,p_pros)
          smearhad_err=dele_from_delp(smear_pro_err,e_pros,p_pros)
          smearpmom=smear_pro
          smearpmom_err=smear_pro_err
          e_hads = e_pros
          p4hads(4)=e_hads
          do i=1,3
            p4hads(i)=p_pros*startdir(i,ipro)
          enddo
          w_had_rec=-pro_mass
        endif
        if(ipi.gt.0.and.ishower(ipi).eq.0
     +    .and.etrueex(trk(ipi)).lt.0.00001)then
          itype=3
          if(nrechit(ipi).gt.i_smear_gaus)then
            CALL RNORMX(rand,1,ranlux)
            smear_pi=smearhad_range*p_pi_true
            smear_pi_err=smearhad_range_err*p_pi_true
          else
            smear_pi=p_pi_true/float(nrechit(ipi))
            smear_pi_err=p_pi_true/float(nrechit(ipi))
            CALL ranlux(rand,1)
            rand=rand-0.5
          endif
          smearpmom=smear_pi 
          smearpmom_err=smear_pi_err 
          p_pis = p_pi_true+rand*smear_pi
          e_pis = sqrt(p_pis**2+pi_mass**2)
          smearhad=dele_from_delp(smear_pi,e_pis,p_pis)
          smearhad_err=dele_from_delp(smear_pi_err,e_pis,p_pis)
          e_hads = e_pis
          p4hads(4)=e_hads
          do i=1,3
            p4hads(i)=p_pis*startdir(i,ipi)
          enddo
          w_had_rec=-pi_mass
        endif
      endif
c 1 hadron, and the hadron does interacts
      if(nprim.eq.2.and.iMuon.gt.0.and.(ipro.gt.0.or.ipi.gt.0))then
        if(ipro.gt.0.and.ishower(ipro).ne.0)then
          itype=4
          smear_pro = smearhad
          smear_pro_err = smearhad_err
          e_pros = pro_mass + ph_sum*cal_e_pro
          p_pros = sqrt(e_pros**2-pro_mass**2)
          p4hads(4)=e_hads
          do i=1,3
            p4hads(i)=p_pros*startdir(i,ipro)
          enddo
          w_had_rec=-pro_mass
        endif
        if(ipi.gt.0.and.ishower(ipi).ne.0)then
          itype=5
          smear_pi = smearhad
          smear_pi_err = smearhad_err
          e_pis = pi_mass + ph_sum*cal_e_pi
          p_pis = sqrt(e_pis**2-pi_mass**2) 
          p4hads(4)=e_hads
          do i=1,3
            p4hads(i)=p_pis*startdir(i,ipi)
          enddo
          w_had_rec=-pi_mass
        endif
      endif
c 2 hadrons, neither interacts
      if(nprim.eq.3.and.iMuon.gt.0.and.ipro.gt.0.and.ipi.gt.0
     +  .and.ishower(ipro).eq.0.and.ishower(ipi).eq.0
     +    .and.etrueex(trk(ipro)).lt.0.00001
     +    .and.etrueex(trk(ipi)).lt.0.00001)then
        itype=6
        if(nhit_pro.gt.i_smear_gaus)then
          CALL RNORMX(rand,1,ranlux)
          smear_pro=smearhad_range*p_pro_true
          smear_pro_err=smearhad_range_err*p_pro_true
        else
          smear_pro=p_pro_true/float(nhit_pro)
          smear_pro_err=p_pro_true/float(nhit_pro)
          CALL ranlux(rand,1)
          rand=rand-0.5
        endif
        p_pros = p_pro_true+rand*smear_pro
        e_pros = sqrt(p_pros**2+pro_mass**2)
        if(nhit_pi.gt.i_smear_gaus)then
          CALL RNORMX(rand,1,ranlux)
          smear_pi=smearhad_range*p_pi_true
          smear_pi_err=smearhad_range_err*p_pi_true
        else
          smear_pi=p_pi_true/float(nhit_pi)
          smear_pi_err=p_pi_true/float(nhit_pi)
          CALL ranlux(rand,1)
          rand=rand-0.5
        endif
        p_pis = p_pi_true+rand*smear_pi
        e_pis = sqrt(p_pis**2+pi_mass**2)
c for dis we want e_had to be the real hadron energy, set no_int_2had=0 
        if(no_int_2had.ne.0)then
           smearpro_e=dele_from_delp(smear_pro_err,e_pros,p_pros)
           smearpi_e=dele_from_delp(smear_pi_err,e_pis,p_pis)
           smearhad_err=sqrt(smearpro_e**2+smearpi_e**2)
           e_hads=e_pros+e_pis
        endif
c but keep the other variables for 2 hadrons
        p4hads(4)=e_pros+e_pis
        w_had_rec2=p4hads(4)**2
        do i=1,3
          p4hads(i)=p_pros*startdir(i,ipro)+p_pis*startdir(i,ipi)
          w_had_rec2=w_had_rec2-p4hads(i)**2
        enddo
        w_had_rec=sqrt(w_had_rec2)
      endif
c 2 hadrons, proton does not interact but pion does
      if(nprim.eq.3.and.iMuon.gt.0.and.ipro.gt.0.and.ipi.gt.0
     +  .and.ishower(ipro).eq.0.and.ishower(ipi).ne.0
     +    .and.etrueex(trk(ipro)).lt.0.00001)then
        itype=7
        if(nhit_pro.gt.i_smear_gaus)then
          CALL RNORMX(rand,1,ranlux)
          smear_pro=smearhad_range*p_pro_true
          smear_pro_err=smearhad_range_err*p_pro_true
        else
          smear_pro=p_pro_true/float(nhit_pro)
          smear_pro_err=p_pro_true/float(nhit_pro)
          CALL ranlux(rand,1)
          rand=rand-0.5
        endif
        p_pros = p_pro_true+rand*smear_pro
        e_pros = sqrt(p_pros**2+pro_mass**2)
        ph_sum=sum_ph(imuon,ipro)
        if(nev.le.nwrt)then
          write(6,860)ph_sum
860       format(' calculate energy without muon  or proton'
     +    ,' sum_ph=',f9.4)
          call wrt_calor(imuon,ipro)
        endif
        e_pis =pi_mass + cal_e_pi*ph_sum
        if(e_pis.le.pi_mass)then
          e_hads=e_hads+pi_mass-e_pis
          e_pis=pi_mass
          p_pis =0
        else
          p_pis =sqrt(e_pis**2-pi_mass**2)
        endif
        p4hads(4)=e_hads
        w_had_rec2=e_hads**2
        do i=1,3
         p4hads(i)=p_pros*startdir(i,ipro)+p_pis*startdir(i,ipi)
         w_had_rec2=w_had_rec2-p4hads(i)**2
        enddo
        w_had_rec=sqrt(w_had_rec2)
      endif
c 2 hadrons , proton interact, pion does not
      if(nprim.eq.3.and.iMuon.gt.0.and.ipro.gt.0.and.ipi.gt.0
     +  .and.ishower(ipro).ne.0.and.ishower(ipi).eq.0
     +    .and.etrueex(trk(ipi)).lt.0.00001)then
        itype=8
        if(nhit_pi.gt.i_smear_gaus)then
          CALL RNORMX(rand,1,ranlux)
          smear_pi=smearhad_range*p_pi_true
          smear_pi_err=smearhad_range_err*p_pi_true
        else
          smear_pi=p_pi_true/float(nhit_pi)
          smear_pi_err=p_pi_true/float(nhit_pi)
          CALL ranlux(rand,1)
          rand=rand-0.5
        endif
        p_pis = p_pi_true+rand*smear_pi
        e_pis = sqrt(p_pis**2+pi_mass**2)
        ph_sum=sum_ph(imuon,ipi)
        if(nev.le.nwrt)then
          write(6,870)ph_sum
870       format(' calculate energy without muon  or pion'
     +    ,' sum_ph=',f9.4)
          call wrt_calor(imuon,ipi) 
        endif
        e_pros =pro_mass + cal_e_pro*ph_sum
        if(e_pros.le.pro_mass)then
          e_hads=e_hads+pro_mass-e_pros
          e_pros=pro_mass
          p_pros =0
        else
          p_pros =sqrt(e_pros**2-pro_mass**2)
        endif
        p4hads(4)=e_hads
        w_had_rec2=e_hads**2
        do i=1,3
         p4hads(i)=p_pros*startdir(i,ipro)+p_pis*startdir(i,ipi)
         w_had_rec2=w_had_rec2-p4hads(i)**2
        enddo
        w_had_rec=sqrt(w_had_rec2)
      endif
c if both interact we can not seperate their energies
c treat like a regular shower
      if(e_hads.le.0)e_hads=0.001
       nwrt=n_wrt
       if(nev.le.nwrt)then 
        write(6,400)
400     format(' in hadron_energy')
        write(6,410)e_hads,ehad_tru,smearhad,smearpmom,rand,ph_sum
410     format(' e_hads = ',f8.3,' ehad_tru =',f8.3,' smearhad=',f7.3
     +  ,' smearpmom=',f7.3,' rand =',f7.3,' ph_sum =',f9.4)
        write(6,420)petrue(trk(Imuon)),e_charge_lep,nt_phtot
420     format(' petrue_muon = ',f8.3,' e_charge_lep =',f8.3
     +   ,' nt_phtot =',5f7.3)
        write(6,430)ishower(imuon),ishower(ipro),ishower(ipi)
     +   ,etrueex(trk(ipro)),etrueex(trk(ipi))
430     format(' ishower muon =',i4,' proton =',i4,' pi =',i4,
     +  ' e escape pro =',f9.4,' pi =',f9.4)
        write(6,440)smear_pro,smear_pi,w_had_rec,p4hads
440     format(' smear_pro =',f7.4,' smear_pi =',f7.4
     +  ,' w_had_rec =',f8.4,' p4hads =',4f9.4)
        write(6,450)smearhad_err,smearpmom_err,smear_pro_err,smear_pi_err
450     format('  smearhad_err=',f7.4,'  smearpmom_err=',f7.4
     +  ,'  smear_pro_err=',f8.4,' smear_pi_err=',4f9.4)
      endif
      RETURN
      END
      real function sum_ph(itrk1,itrk2)
#include "ntuple.inc"
      sum_ph = 0
      do 120 ical = 1,nCal
        if(itrk1.le.0)go to 40 
         if(itCal(ical).eq.trk(itrk1))go to 120
40       continue
          if(itrk2.le.0)go to 50 
           if(itCal(ical).eq.trk(itrk2))go to 120
50         continue
            sum_ph = sum_ph+eCal(iCal) 
     +        *(dxActiveCal(iCal)+dxPassiveCal(iCal))/dxActiveCal(iCal) 
120   continue
      return
      end
      subroutine wrt_calor(itrk1,itrk2)
#include "ntuple.inc"
      write(6,690)nev,itrk1,itrk2
690   format('  in wrt_calor, nev =',i4,' itrk1 = ',i3,' itrk2 =',i3)
      write(6,700)
700   format('ical lay mod  trk   x     ` y      z      e ', 
     +'     dxAct    dxPas      sumph')
      sum_ph = 0
      do 120 ical = 1, nCal
        if(itrk1.le.0)go to 40 
         if(itCal(ical).eq.trk(itrk1))go to 120
40       continue
          if(itrk2.le.0)go to 50 
           if(itCal(ical).eq.trk(itrk2))go to 120
50         continue
            sum_ph = sum_ph+eCal(iCal) 
     +        *(dxActiveCal(iCal)+dxPassiveCal(iCal))/dxActiveCal(iCal) 
      write(6,300)ical,lCal(iCal),modCal(iCal)
     + ,itcal(iCal),xCal(iCal)
     + ,yCal(iCal),zCal(iCal),eCal(iCal)
     + ,dxActiveCal(iCal),dxPassiveCal(iCal),sum_ph 
300   format( 4i4,3f7.2,3f9.4,f11.4)
120   continue
130   continue
      return
      end
*
c This smears truth information for interacting hadrons
      subroutine hadron_energy_sm(reconList,nprim,e_hads,e_pros,e_pis
     +,w_had_rec,p4hads,ehad_tru,smearhad_err,smearpmom_err
     +,itype,no_int_2had)
c not clear if hadron energy should be energy of non interacting particle or not
c compute p4hads if you can, ie need to know the 
c momentum of all the identified hadrons 
c imuon, ipro,ipi, recon pointers to imuon,proton,and pion 
c e_hads -smeared hadron energy
c itype  tells which one was done
c itype 
c   0  regular hadron smearing
c   1  1 primary - take hadron energy
c   2  1 hadrons - proton, does not interact
c   3  1 hadrons - pion, does not interact
c   4  1 hadron  - proton, interacts
c   5  1 hadron  - proton, interacts
c   6  2 hadrons, proton and pion do not interact
c   no_int_2had=0, then the hadron energy return is the nominal one
c   no_int_2had=!0, then the hadron energy returned is the sum of the 2 hadrons
c   7  2 hadrons, proton does not interact, pion does
c   8  2 hadrons, proton interact, pion does not
c   e_pro is the smeared energy of he proton 
c   e_pi  is the smeared energy of the pion
c 
C
#include "ntuple.inc"
#include "vertexNtuple.inc"
#include "fitterNtuple.inc"
#include "vector.inc"
#include "hb_common.inc"
      real p4hads(4)
      integer reconList(5)
      integer iMuon,ipro,ndaughter,num_hits
      external ranlux
      real rand,ran2
      integer i_smear_gaus/6/
      real pro_mass/0.9383/
      real pi_mass/0.1396/
C
      iMuon=reconList(1)
      ipro=reconList(2)
      ipi=reconList(3)
      nhit_pro=nrechit(ipro)
      nhit_pi=nrechit(ipi)
      e_pro_true=0
      e_pi_true=0
      e_charge_lep=0
      smear_pro=0.0
      smear_pi=0.0
      smear_pro_err=0.0
      smear_pi_err=0.0
      itype=0
      e_pros = 0
      e_pis = 0
      p_pros = 0
      p_pis = 0
      ehad_tru=0
      e_hads = 0
      itpro=0
      itpi=0
      ran2=0
      w_had_rec=0
      w_had_rec2=0
      do i=1,4
        p4hads(i)=0
      enddo
      if(ipro.gt.0)then
        itpro=trk(Ipro)
        e_pro_true=petrue(itpro)
        p_pro_true=pxtrue(itpro)**2+pytrue(itpro)**2+pztrue(itpro)**2
        p_pro_true=sqrt(p_pro_true)
      endif
      if(ipi.gt.0)then
        itpi=trk(Ipi)
        e_pi_true=petrue(itpi)
        p_pi_true=pxtrue(itpi)**2+pytrue(itpi)**2+pztrue(itpi)**2
        p_pi_true=sqrt(p_pi_true)
      endif
c get charged leptonic energy
      do ilep=1,nt_nleptons
        if(abs(nt_lepton(ilep)).eq.11.or.abs(nt_lepton(ilep)).eq.13) then
           e_charge_lep=e_charge_lep+nt_plepton(4,ilep)
        endif
      enddo
c subtract off energy of identified muon from total
c phtot(4) is the energy and phtot(5) is the total momentum
      if(Imuon.gt.0)then
        ehad_tru=nt_phtot(4)+e_charge_lep-petrue(trk(Imuon))
      else
        ehad_tru=nt_phtot(4)
      endif
c default smearing and hadron energy
      smearhad = smear_had(ehad_tru)
      CALL RNORMX(rand,1,ranlux)
      e_hads = ehad_tru+rand*smearhad
      itype=1
      smearhad_err = smear_had_err(ehad_tru)
      pmomtot = sqrt(ehad_tru**2-pro_mass**2)
      smearpmom = delp_from_dele(smearhad,ehad_tru,pmomtot)
      smearpmom_err = delp_from_dele(smearhad_err,ehad_tru,pmomtot)
      CALL RNORMX(rand,1,ranlux)
      CALL RNORMX(ran2,1,ranlux)
c 1 hadron, and the hadron does not interact
      if(nprim.eq.2.and.iMuon.gt.0.and.(ipro.gt.0.or.ipi.gt.0))then
        if(ipro.gt.0.and.ishower(ipro).eq.0
     +    .and.etrueex(trk(ipro)).lt.0.00001)then
          itype=2
          if(nhit_pro.gt.i_smear_gaus)then
            smear_pro=smearhad_range*p_pro_true 
            smear_pro_err=smearhad_range_err*p_pro_true 
          else
            smear_pro=1.0/float(nhit_pro)
            smear_pro_err=1.0/float(nhit_pro)
            CALL ranlux(rand,1)
            rand=rand-0.5
          endif
          smearhad=dele_from_delp(smear_pro,e_pro_true,p_pro_true)
          smearhad_err=dele_from_delp(smear_pro_err,e_pro_true,p_pro_true)
          smearpmom=smear_pro
          smearpmom_err=smear_pro_err
          p_pros = p_pro_true+rand*smearpmom
          e_pros = sqrt(p_pros**2+pro_mass**2)
          e_hads = e_pros
          p4hads(4)=e_hads
          do i=1,3
            p4hads(i)=p_pros*startdir(i,ipro)
          enddo
          w_had_rec=-pro_mass
        endif
        if(ipi.gt.0.and.ishower(ipi).eq.0
     +    .and.etrueex(trk(ipi)).lt.0.00001)then
          itype=3
          if(nrechit(ipi).gt.i_smear_gaus)then
            smear_pi=smearhad_range*p_pi_true
            smear_pi_err=smearhad_range_err*p_pi_true
          else
            smear_pi=p_pi_true/float(nrechit(ipi))
            smear_pi_err=p_pi_true/float(nrechit(ipi))
            CALL ranlux(rand,1)
            rand=rand-0.5
          endif
          smearhad=dele_from_delp(smear_pi,e_pi_true,p_pi_true)
          smearhad_err=dele_from_delp(smear_pi_err,e_pi_true,p_pi_true)
          p_pis = p_pi_true+rand*smearhad
          e_pis = sqrt(p_pis**2+pi_mass**2)
          e_hads = e_pis
          p4hads(4)=e_hads
          do i=1,3
            p4hads(i)=p_pis*startdir(i,ipi)
          enddo
          w_had_rec=-pi_mass
        endif
      endif
c 1 hadron, and the hadron does interacts
      if(nprim.eq.2.and.iMuon.gt.0.and.(ipro.gt.0.or.ipi.gt.0))then
        if(ipro.gt.0.and.ishower(ipro).ne.0)then
          itype=4
          smear_pro = smearhad
          smear_pro_err = smearhad_err
          e_pros = e_hads
          p_pros = sqrt(e_pros**2-pro_mass**2)
          p4hads(4)=e_hads
          do i=1,3
            p4hads(i)=p_pros*startdir(i,ipro)
          enddo
          w_had_rec=-pro_mass
        endif
        if(ipi.gt.0.and.ishower(ipi).ne.0)then
          itype=5
          smear_pi = smearhad
          smear_pi_err = smearhad_err
          e_pis = e_hads 
          p_pis = sqrt(e_pis**2-pi_mass**2) 
          p4hads(4)=e_hads
          do i=1,3
            p4hads(i)=p_pis*startdir(i,ipi)
          enddo
          w_had_rec=-pi_mass
        endif
      endif
c 2 hadrons, neither interacts
      if(nprim.eq.3.and.iMuon.gt.0.and.ipro.gt.0.and.ipi.gt.0
     +  .and.ishower(ipro).eq.0.and.ishower(ipi).eq.0
     +    .and.etrueex(trk(ipro)).lt.0.00001
     +    .and.etrueex(trk(ipi)).lt.0.00001)then
        itype=6
        if(nhit_pro.gt.i_smear_gaus)then
          smear_pro=smearhad_range*p_pro_true
          smear_pro_err=smearhad_range_err*p_pro_true
        else
          smear_pro=p_pro_true/float(nhit_pro)
          smear_pro_err=p_pro_true/float(nhit_pro)
          CALL ranlux(rand,1)
          rand=rand-0.5
        endif
        p_pros = p_pro_true+rand*smear_pro
        e_pros = sqrt(p_pros**2+pro_mass**2)
        if(nhit_pi.gt.i_smear_gaus)then
          smear_pi=smearhad_range*p_pi_true
          smear_pi_err=smearhad_range_err*p_pi_true
        else
          smear_pi=p_pi_true/float(nhit_pi)
          smear_pi_err=p_pi_true/float(nhit_pi)
          CALL ranlux(rand,1)
          rand=rand-0.5
        endif
        p_pis = p_pi_true+rand*smear_pi
        e_pis = sqrt(p_pis**2+pi_mass**2)
c for dis we want e_had to be the real hadron energy, set no_int_2had=0 
        if(no_int_2had.ne.0)then
           smearpro_e=dele_from_delp(smear_pro_err,e_pro_true,p_pro_true)
           smearpi_e=dele_from_delp(smear_pi_err,e_pi_true,p_pi_true)
           smearhad_err=sqrt(smearpro_e**2+smearpi_e**2)
           e_hads=e_pros+e_pis
        endif
c but keep the other variables for 2 hadrons
        p4hads(4)=e_pros+e_pis
        w_had_rec2=p4hads(4)**2
        do i=1,3
          p4hads(i)=p_pros*startdir(i,ipro)+p_pis*startdir(i,ipi)
          w_had_rec2=w_had_rec2-p4hads(i)**2
        enddo
        w_had_rec=sqrt(w_had_rec2)
      endif
c 2 hadrons, proton does not interact but pion does
      if(nprim.eq.3.and.iMuon.gt.0.and.ipro.gt.0.and.ipi.gt.0
     +  .and.ishower(ipro).eq.0.and.ishower(ipi).ne.0
     +    .and.etrueex(trk(ipro)).lt.0.00001)then
        itype=7
        if(nhit_pro.gt.i_smear_gaus)then
          smear_pro=smearhad_range*p_pro_true
          smear_pro_err=smearhad_range_err*p_pro_true
        else
          smear_pro=p_pro_true/float(nhit_pro)
          smear_pro_err=p_pro_true/float(nhit_pro)
          CALL ranlux(rand,1)
          rand=rand-0.5
        endif
        p_pros = p_pro_true+rand*smear_pro
        e_pros = sqrt(p_pros**2+pro_mass**2)
        e_pis = e_hads-e_pros
        if(e_pis.le.pi_mass)then
          e_hads=e_hads+pi_mass-e_pis
          e_pis=pi_mass
          p_pis =0
        else
          p_pis =sqrt(e_pis**2-pi_mass**2)
        endif
        p4hads(4)=e_hads
        w_had_rec2=e_hads**2
        do i=1,3
         p4hads(i)=p_pros*startdir(i,ipro)+p_pis*startdir(i,ipi)
         w_had_rec2=w_had_rec2-p4hads(i)**2
        enddo
        w_had_rec=sqrt(w_had_rec2)
      endif
c 2 hadrons , proton interact, pion does not
      if(nprim.eq.3.and.iMuon.gt.0.and.ipro.gt.0.and.ipi.gt.0
     +  .and.ishower(ipro).ne.0.and.ishower(ipi).eq.0
     +  .and.etrueex(trk(ipi)).lt.0.00001)then
        itype=8
        if(nhit_pi.gt.i_smear_gaus)then
          smear_pi=smearhad_range*p_pi_true
          smear_pi_err=smearhad_range_err*p_pi_true
        else
          smear_pi=p_pi_true/float(nhit_pi)
          smear_pi_err=p_pi_true/float(nhit_pi)
          CALL ranlux(rand,1)
          rand=rand-0.5
        endif
        p_pis = p_pi_true+rand*smear_pi
        e_pis = sqrt(p_pis**2+pi_mass**2)
        e_pros =e_hads-e_pis
        if(e_pros.le.pro_mass)then
          e_hads=e_hads+pro_mass-e_pros
          e_pros=pro_mass
          p_pros =0
        else
          p_pros =sqrt(e_pros**2-pro_mass**2)
        endif
        p4hads(4)=e_hads
        w_had_rec2=e_hads**2
        do i=1,3
         p4hads(i)=p_pros*startdir(i,ipro)+p_pis*startdir(i,ipi)
         w_had_rec2=w_had_rec2-p4hads(i)**2
        enddo
        w_had_rec=sqrt(w_had_rec2)
      endif
c if both interact we can not seperate their energies
c treat like a regular shower
      if(e_hads.le.0)e_hads=0.001
       if(nev.le.nwrt)then 
        write(6,400)
400     format(' in hadron_energy')
        write(6,410)e_hads,ehad_tru,smearhad,smearpmom,rand,ran2
410     format(' e_hads = ',f8.3,' ehad_tru =',f8.3,' smearhad=',f7.3
     +  ,' smearpmom=',f7.3,' rand =',f7.3,' ran2 =',f7.3)
        write(6,420)petrue(trk(Imuon)),e_charge_lep,nt_phtot
420     format(' petrue_muon = ',f8.3,' e_charge_lep =',f8.3
     +   ,' nt_phtot =',5f7.3)
        write(6,430)ishower(imuon),ishower(ipro),ishower(ipi)
     +   ,etrueex(trk(ipro)),etrueex(trk(ipi))
430     format(' ishower muon =',i4,' proton =',i4,' pi =',i4,
     +  '  e escape pro =',f9.4,' pi =',f9.4)
        write(6,440)smear_pro,smear_pi,w_had_rec,p4hads
440     format(' smear_pro =',f7.4,' smear_pi =',f7.4
     +  ,' w_had_rec =',f8.4,' p4hads =',4f9.4)
        write(6,450)smearhad_err,smearpmom_err,smear_pro_err,smear_pi_err
450     format('  smearhad_err=',f7.4,'  smearpmom_err=',f7.4
     +  ,'  smear_pro_err=',f8.4,' smear_pi_err=',4f9.4)
      endif
      RETURN
      END
c
      real function delp_from_dele(dele,ene,pmom)
c gives delta p from delta e
c
c *****************
c
      delP_from_delE = 0
      if(pmom.gt.0)then
        delP_from_delE = 
     +  pmom*(sqrt(1+(2.0*ene*dele+dele**2)/pmom**2)-1)
      endif
      return
      end
c
      real function dele_from_delp(delp,ene,pmom)
c gives delta e from delta p
c
c *****************
c
      delE_from_delP = 0
      if(pmom.gt.0)then
        delE_from_delP = 
     +  ene*(sqrt(1+(2.0*pmom*delp+delp**2)/ene**2)-1)
      endif
      return
      end

                                                                                     
      REAL FUNCTION smear_had(ehad)
#include "hb_common.inc"
      real pro_mass/0.9383/
c
c ****************
c
      smear_had=0
      if(ehad-pro_mass.ge.0.001)then
        smear_had = (ehad-pro_mass)*smearhad_c
     1     +smearhad_e*sqrt(ehad-pro_mass)
      endif
      return
      end
      REAL FUNCTION smear_had_err(ehad)
#include "hb_common.inc"
      real pro_mass/0.9383/
c
c ****************
c
      smear_had=0
      if(ehad-pro_mass.ge.0.001)then
        smear_had_err = (ehad-pro_mass)*smearhad_c_err
     1     +smearhad_e_err*sqrt(ehad-pro_mass)
      endif
      return
      end
